library IEEE;
use IEEE.std_logic_1164.all;

entity one_bit_full_adder is
   port (a,b,cin : in STD_LOGIC;
         s, cout : out STD_LOGIC);   
end one_bit_full_adder;

architecture behaviour of one_bit_full_adder is
begin
     s <= a xor b xor cin;
     cout <= (a and cin) or (a and b) or (b and cin);
end behaviour;

architecture behaviour_mux of one_bit_full_adder is

  component mux_4_1
    port (a,b,c,d,s1,s2 : in STD_LOGIC;
          q             : out STD_LOGIC
    );
  end component;
  
  signal cin_not,true,false : STD_LOGIC;

begin

  cin_not <= (not cin);
  true <= '1';
  false <= '0';

  mux_4_1_s: mux_4_1 port map(
    a => cin,
    b => cin_not,
    c => cin_not,
    d => cin,
    s1 => a,
    s2 => b,
    q => s
  );
  
  mux_4_1_c: mux_4_1 port map(
    a => false,
    b => cin,
    c => cin,
    d => true,
    s1 => a,
    s2 => b,
    q => cout
  );

       
end behaviour_mux;
